Add script for building chroot
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 ACLOCAL_AMFLAGS = -I autotools
24 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
25 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
26 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
27 CHECK_HEADER = $(top_srcdir)/autotools/check-header
28 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
29 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
30 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
31 CHECK_VERSION = $(top_srcdir)/autotools/check-version
32 CHECK_NEWS = $(top_srcdir)/autotools/check-news
33 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
34 DOCPP = $(top_srcdir)/autotools/docpp
35 REPLACE_VARS_SED = autotools/replace_vars.sed
36 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
37 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
38 SHELL_ENV_INIT = autotools/shell-env-init
39
40 # Note: these are automake-specific variables, and must be named after
41 # the directory + 'dir' suffix
42 clientdir = $(pkgpythondir)/client
43 hypervisordir = $(pkgpythondir)/hypervisor
44 httpdir = $(pkgpythondir)/http
45 masterddir = $(pkgpythondir)/masterd
46 confddir = $(pkgpythondir)/confd
47 rapidir = $(pkgpythondir)/rapi
48 serverdir = $(pkgpythondir)/server
49 watcherdir = $(pkgpythondir)/watcher
50 impexpddir = $(pkgpythondir)/impexpd
51 utilsdir = $(pkgpythondir)/utils
52 toolsdir = $(pkglibdir)/tools
53 iallocatorsdir = $(pkglibdir)/iallocators
54 pytoolsdir = $(pkgpythondir)/tools
55 docdir = $(datadir)/doc/$(PACKAGE)
56 myexeclibdir = $(pkglibdir)
57
58 # Delete output file if an error occurred while building it
59 .DELETE_ON_ERROR:
60
61 HS_DIRS = \
62         src \
63         src/Ganeti \
64         src/Ganeti/Block \
65         src/Ganeti/Block/Drbd \
66         src/Ganeti/Confd \
67         src/Ganeti/Curl \
68         src/Ganeti/DataCollectors \
69         src/Ganeti/HTools \
70         src/Ganeti/HTools/Backend \
71         src/Ganeti/HTools/Program \
72         src/Ganeti/Hypervisor \
73         src/Ganeti/Hypervisor/Xen \
74         src/Ganeti/Monitoring \
75         src/Ganeti/Query \
76         test/hs \
77         test/hs/Test \
78         test/hs/Test/Ganeti \
79         test/hs/Test/Ganeti/Block \
80         test/hs/Test/Ganeti/Block/Drbd \
81         test/hs/Test/Ganeti/Confd \
82         test/hs/Test/Ganeti/HTools \
83         test/hs/Test/Ganeti/HTools/Backend \
84         test/hs/Test/Ganeti/Hypervisor \
85         test/hs/Test/Ganeti/Hypervisor/Xen \
86         test/hs/Test/Ganeti/Query
87
88 # Haskell directories without the roots (src, test/hs)
89 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
90
91 DIRS = \
92         $(HS_DIRS) \
93         autotools \
94         daemons \
95         devel \
96         devel/data \
97         doc \
98         doc/css \
99         doc/examples \
100         doc/examples/gnt-debug \
101         doc/examples/hooks \
102         test/data/htools \
103         test/data/htools/rapi \
104         test/hs/shelltests \
105         lib \
106         lib/build \
107         lib/client \
108         lib/confd \
109         lib/http \
110         lib/hypervisor \
111         lib/impexpd \
112         lib/masterd \
113         lib/rapi \
114         lib/server \
115         lib/tools \
116         lib/utils \
117         lib/watcher \
118         man \
119         qa \
120         test \
121         test/data \
122         test/data/bdev-rbd \
123         test/data/ovfdata \
124         test/data/ovfdata/other \
125         test/py \
126         tools
127
128 ALL_APIDOC_HS_DIRS = \
129         $(APIDOC_HS_DIR) \
130         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
131
132 BUILDTIME_DIR_AUTOCREATE = \
133         scripts \
134         $(APIDOC_DIR) \
135         $(ALL_APIDOC_HS_DIRS) \
136         $(APIDOC_PY_DIR) \
137         $(COVERAGE_DIR) \
138         $(COVERAGE_HS_DIR) \
139         $(COVERAGE_PY_DIR) \
140         .hpc
141
142 BUILDTIME_DIRS = \
143         $(BUILDTIME_DIR_AUTOCREATE) \
144         doc/html \
145         doc/man-html
146
147 DIRCHECK_EXCLUDE = \
148         $(BUILDTIME_DIRS) \
149         ganeti-[0-9]*.[0-9]*.[0-9]* \
150         doc/html/_* \
151         doc/man-html/_* \
152         autom4te.cache
153
154 # some helper vars
155 COVERAGE_DIR = doc/coverage
156 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
157 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
158 APIDOC_DIR = doc/api
159 APIDOC_PY_DIR = $(APIDOC_DIR)/py
160 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
161
162 MAINTAINERCLEANFILES = \
163         $(maninput) \
164         doc/install-quick.rst \
165         doc/news.rst \
166         doc/upgrade.rst \
167         vcs-version
168
169 maintainer-clean-local:
170         rm -rf $(BUILDTIME_DIRS)
171
172 CLEANFILES = \
173         $(addsuffix /*.py[co],$(DIRS)) \
174         $(addsuffix /*.hi,$(HS_DIRS)) \
175         $(addsuffix /*.o,$(HS_DIRS)) \
176         $(PYTHON_BOOTSTRAP) \
177         epydoc.conf \
178         $(REPLACE_VARS_SED) \
179         $(SHELL_ENV_INIT) \
180         daemons/daemon-util \
181         daemons/ganeti-cleaner \
182         devel/squeeze-amd64.tar.gz \
183         devel/squeeze-amd64.conf \
184         $(mandocrst) \
185         doc/manpages-enabled.rst \
186         $(BUILT_EXAMPLES) \
187         doc/examples/bash_completion \
188         doc/examples/bash_completion-debug \
189         lib/_generated_rpc.py \
190         $(man_MANS) \
191         $(manhtml) \
192         tools/kvm-ifup \
193         tools/vcluster-setup \
194         stamp-directories \
195         stamp-srclinks \
196         $(nodist_pkgpython_PYTHON) \
197         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
198         $(HS_BUILT_TEST_HELPERS) \
199         src/ganeti-confd \
200         src/ganeti-mond \
201         .hpc/*.mix src/*.tix test/hs/*.tix \
202         doc/hs-lint.html
203
204 GENERATED_FILES = \
205         $(built_base_sources) \
206         $(BUILT_PYTHON_SOURCES) \
207         $(PYTHON_BOOTSTRAP)
208
209 HS_GENERATED_FILES =
210 if WANT_HTOOLS
211 HS_GENERATED_FILES += $(HS_PROGS)
212 if ENABLE_CONFD
213 HS_GENERATED_FILES += src/hconfd src/ganeti-confd
214 endif
215
216 if ENABLE_MOND
217 HS_GENERATED_FILES += src/ganeti-mond
218 endif
219 endif
220
221 built_base_sources = \
222         stamp-directories \
223         stamp-srclinks
224
225 built_python_base_sources = \
226         lib/_autoconf.py \
227         lib/_vcsversion.py
228
229 BUILT_PYTHON_SOURCES = \
230         $(built_python_base_sources) \
231         lib/_generated_rpc.py
232
233 # Generating the RPC wrappers depends on many things, so make sure
234 # it's built at the end of the built sources
235 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
236
237 # these are all built from the underlying %.in sources
238 BUILT_EXAMPLES = \
239         doc/examples/ganeti-kvm-poweroff.initd \
240         doc/examples/ganeti.cron \
241         doc/examples/ganeti.initd \
242         doc/examples/ganeti-master-role.ocf \
243         doc/examples/ganeti-node-role.ocf \
244         doc/examples/gnt-config-backup \
245         doc/examples/hooks/ipsec
246
247 nodist_pkgpython_PYTHON = \
248         $(BUILT_PYTHON_SOURCES)
249
250 noinst_PYTHON = \
251         lib/build/__init__.py \
252         lib/build/shell_example_lexer.py \
253         lib/build/sphinx_ext.py
254
255 pkgpython_PYTHON = \
256         lib/__init__.py \
257         lib/asyncnotifier.py \
258         lib/backend.py \
259         lib/bdev.py \
260         lib/bootstrap.py \
261         lib/cli.py \
262         lib/cmdlib.py \
263         lib/compat.py \
264         lib/config.py \
265         lib/constants.py \
266         lib/daemon.py \
267         lib/errors.py \
268         lib/ht.py \
269         lib/jqueue.py \
270         lib/jstore.py \
271         lib/locking.py \
272         lib/luxi.py \
273         lib/mcpu.py \
274         lib/netutils.py \
275         lib/objects.py \
276         lib/opcodes.py \
277         lib/outils.py \
278         lib/ovf.py \
279         lib/pathutils.py \
280         lib/qlang.py \
281         lib/query.py \
282         lib/rpc.py \
283         lib/rpc_defs.py \
284         lib/runtime.py \
285         lib/serializer.py \
286         lib/ssconf.py \
287         lib/ssh.py \
288         lib/storage.py \
289         lib/uidpool.py \
290         lib/vcluster.py \
291         lib/network.py \
292         lib/workerpool.py
293
294 client_PYTHON = \
295         lib/client/__init__.py \
296         lib/client/gnt_backup.py \
297         lib/client/gnt_cluster.py \
298         lib/client/gnt_debug.py \
299         lib/client/gnt_group.py \
300         lib/client/gnt_instance.py \
301         lib/client/gnt_job.py \
302         lib/client/gnt_node.py \
303         lib/client/gnt_network.py \
304         lib/client/gnt_os.py \
305         lib/client/gnt_storage.py
306
307 hypervisor_PYTHON = \
308         lib/hypervisor/__init__.py \
309         lib/hypervisor/hv_base.py \
310         lib/hypervisor/hv_chroot.py \
311         lib/hypervisor/hv_fake.py \
312         lib/hypervisor/hv_kvm.py \
313         lib/hypervisor/hv_lxc.py \
314         lib/hypervisor/hv_xen.py
315
316 rapi_PYTHON = \
317         lib/rapi/__init__.py \
318         lib/rapi/baserlib.py \
319         lib/rapi/client.py \
320         lib/rapi/client_utils.py \
321         lib/rapi/connector.py \
322         lib/rapi/rlib2.py \
323         lib/rapi/testutils.py
324
325 http_PYTHON = \
326         lib/http/__init__.py \
327         lib/http/auth.py \
328         lib/http/client.py \
329         lib/http/server.py
330
331 confd_PYTHON = \
332         lib/confd/__init__.py \
333         lib/confd/client.py
334
335 masterd_PYTHON = \
336         lib/masterd/__init__.py \
337         lib/masterd/iallocator.py \
338         lib/masterd/instance.py
339
340 impexpd_PYTHON = \
341         lib/impexpd/__init__.py
342
343 watcher_PYTHON = \
344         lib/watcher/__init__.py \
345         lib/watcher/nodemaint.py \
346         lib/watcher/state.py
347
348 server_PYTHON = \
349         lib/server/__init__.py \
350         lib/server/masterd.py \
351         lib/server/noded.py \
352         lib/server/rapi.py
353
354 pytools_PYTHON = \
355         lib/tools/__init__.py \
356         lib/tools/burnin.py \
357         lib/tools/ensure_dirs.py \
358         lib/tools/node_cleanup.py \
359         lib/tools/node_daemon_setup.py \
360         lib/tools/prepare_node_join.py
361
362 utils_PYTHON = \
363         lib/utils/__init__.py \
364         lib/utils/algo.py \
365         lib/utils/filelock.py \
366         lib/utils/hash.py \
367         lib/utils/io.py \
368         lib/utils/log.py \
369         lib/utils/lvm.py \
370         lib/utils/mlock.py \
371         lib/utils/nodesetup.py \
372         lib/utils/process.py \
373         lib/utils/retry.py \
374         lib/utils/text.py \
375         lib/utils/wrapper.py \
376         lib/utils/x509.py
377
378 docinput = \
379         doc/conf.py \
380         doc/css/style.css \
381         doc/admin.rst \
382         doc/cluster-merge.rst \
383         doc/design-2.0.rst \
384         doc/design-2.1.rst \
385         doc/design-2.2.rst \
386         doc/design-2.3.rst \
387         doc/design-2.4.rst \
388         doc/design-2.5.rst \
389         doc/design-2.6.rst \
390         doc/design-2.7.rst \
391         doc/design-autorepair.rst \
392         doc/design-bulk-create.rst \
393         doc/design-chained-jobs.rst \
394         doc/design-cpu-pinning.rst \
395         doc/design-draft.rst \
396         doc/design-htools-2.3.rst \
397         doc/design-http-server.rst \
398         doc/design-impexp2.rst \
399         doc/design-lu-generated-jobs.rst \
400         doc/design-linuxha.rst \
401         doc/design-multi-reloc.rst \
402         doc/design-network.rst \
403         doc/design-node-add.rst \
404         doc/design-oob.rst \
405         doc/design-ovf-support.rst \
406         doc/design-opportunistic-locking.rst \
407         doc/design-partitioned.rst \
408         doc/design-query-splitting.rst \
409         doc/design-query2.rst \
410         doc/design-reason-trail.rst \
411         doc/design-resource-model.rst \
412         doc/design-restricted-commands.rst \
413         doc/design-shared-storage.rst \
414         doc/design-monitoring-agent.rst \
415         doc/design-virtual-clusters.rst \
416         doc/design-x509-ca.rst \
417         doc/design-hroller.rst \
418         doc/design-storagespace.rst \
419         doc/devnotes.rst \
420         doc/glossary.rst \
421         doc/hooks.rst \
422         doc/iallocator.rst \
423         doc/index.rst \
424         doc/install-quick.rst \
425         doc/install.rst \
426         doc/locking.rst \
427         doc/manpages-disabled.rst \
428         doc/move-instance.rst \
429         doc/news.rst \
430         doc/ovfconverter.rst \
431         doc/rapi.rst \
432         doc/security.rst \
433         doc/upgrade.rst \
434         doc/virtual-cluster.rst \
435         doc/walkthrough.rst
436
437 # Generates file names such as "doc/man-gnt-instance.rst"
438 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
439
440 # Haskell programs to be installed in $PREFIX/bin
441 HS_BIN_PROGS=src/htools
442
443 # Haskell programs to be installed in the MYEXECLIB dir
444 HS_MYEXECLIB_PROGS=src/mon-collector
445
446 # Haskell programs to be compiled by "make really-all"
447 HS_COMPILE_PROGS= \
448         src/ganeti-mond \
449         src/hconfd \
450         src/rpc-test
451
452 # All Haskell non-test programs to be compiled but not automatically installed
453 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
454
455 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
456 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
457
458 HS_ALL_PROGS = \
459         $(HS_PROGS) \
460         test/hs/hpc-htools \
461         test/hs/hpc-mon-collector \
462         test/hs/htest \
463         $(HS_COMPILE_PROGS)
464
465 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
466 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
467
468 HFLAGS = \
469         -O -Wall -Werror -isrc \
470         -fwarn-monomorphism-restriction \
471         -fwarn-tabs \
472         $(GHC_BYVERSION_FLAGS)
473
474 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
475 HEXTRA =
476 # internal extra flags (used for test/hs/htest mainly)
477 HEXTRA_INT =
478 # exclude options for coverage reports
479 HPCEXCL = --exclude Main \
480         --exclude Ganeti.Constants \
481         --exclude Ganeti.HTools.QC \
482         --exclude Ganeti.THH \
483         --exclude Ganeti.Version \
484         --exclude Test.Ganeti.Attoparsec \
485         --exclude Test.Ganeti.TestCommon \
486         --exclude Test.Ganeti.TestHTools \
487         --exclude Test.Ganeti.TestHelper \
488         --exclude Test.Ganeti.TestImports \
489         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
490
491 HS_LIB_SRCS = \
492         src/Ganeti/Block/Drbd/Types.hs \
493         src/Ganeti/Block/Drbd/Parser.hs \
494         src/Ganeti/BasicTypes.hs \
495         src/Ganeti/Common.hs \
496         src/Ganeti/Compat.hs \
497         src/Ganeti/Confd/Client.hs \
498         src/Ganeti/Confd/Server.hs \
499         src/Ganeti/Confd/Types.hs \
500         src/Ganeti/Confd/Utils.hs \
501         src/Ganeti/Config.hs \
502         src/Ganeti/Curl/Multi.hs \
503         src/Ganeti/Daemon.hs \
504         src/Ganeti/DataCollectors/CLI.hs \
505         src/Ganeti/DataCollectors/Drbd.hs \
506         src/Ganeti/DataCollectors/Program.hs \
507         src/Ganeti/DataCollectors/Types.hs \
508         src/Ganeti/Errors.hs \
509         src/Ganeti/HTools/Backend/IAlloc.hs \
510         src/Ganeti/HTools/Backend/Luxi.hs \
511         src/Ganeti/HTools/Backend/Rapi.hs \
512         src/Ganeti/HTools/Backend/Simu.hs \
513         src/Ganeti/HTools/Backend/Text.hs \
514         src/Ganeti/HTools/CLI.hs \
515         src/Ganeti/HTools/Cluster.hs \
516         src/Ganeti/HTools/Container.hs \
517         src/Ganeti/HTools/ExtLoader.hs \
518         src/Ganeti/HTools/Graph.hs \
519         src/Ganeti/HTools/Group.hs \
520         src/Ganeti/HTools/Instance.hs \
521         src/Ganeti/HTools/Loader.hs \
522         src/Ganeti/HTools/Node.hs \
523         src/Ganeti/HTools/PeerMap.hs \
524         src/Ganeti/HTools/Program/Hail.hs \
525         src/Ganeti/HTools/Program/Harep.hs \
526         src/Ganeti/HTools/Program/Hbal.hs \
527         src/Ganeti/HTools/Program/Hcheck.hs \
528         src/Ganeti/HTools/Program/Hinfo.hs \
529         src/Ganeti/HTools/Program/Hscan.hs \
530         src/Ganeti/HTools/Program/Hspace.hs \
531         src/Ganeti/HTools/Program/Hroller.hs \
532         src/Ganeti/HTools/Program/Main.hs \
533         src/Ganeti/HTools/Types.hs \
534         src/Ganeti/Hypervisor/Xen/XmParser.hs \
535         src/Ganeti/Hypervisor/Xen/Types.hs \
536         src/Ganeti/Hash.hs \
537         src/Ganeti/JQueue.hs \
538         src/Ganeti/JSON.hs \
539         src/Ganeti/Jobs.hs \
540         src/Ganeti/Logging.hs \
541         src/Ganeti/Luxi.hs \
542         src/Ganeti/Monitoring/Server.hs \
543         src/Ganeti/Network.hs \
544         src/Ganeti/Objects.hs \
545         src/Ganeti/OpCodes.hs \
546         src/Ganeti/OpParams.hs \
547         src/Ganeti/Path.hs \
548         src/Ganeti/Query/Common.hs \
549         src/Ganeti/Query/Export.hs \
550         src/Ganeti/Query/Filter.hs \
551         src/Ganeti/Query/Group.hs \
552         src/Ganeti/Query/Job.hs \
553         src/Ganeti/Query/Language.hs \
554         src/Ganeti/Query/Network.hs \
555         src/Ganeti/Query/Node.hs \
556         src/Ganeti/Query/Query.hs \
557         src/Ganeti/Query/Server.hs \
558         src/Ganeti/Query/Types.hs \
559         src/Ganeti/Rpc.hs \
560         src/Ganeti/Runtime.hs \
561         src/Ganeti/Ssconf.hs \
562         src/Ganeti/THH.hs \
563         src/Ganeti/Types.hs \
564         src/Ganeti/Utils.hs
565
566 HS_TEST_SRCS = \
567         test/hs/Test/Ganeti/Attoparsec.hs \
568         test/hs/Test/Ganeti/BasicTypes.hs \
569         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
570         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
571         test/hs/Test/Ganeti/Common.hs \
572         test/hs/Test/Ganeti/Confd/Types.hs \
573         test/hs/Test/Ganeti/Confd/Utils.hs \
574         test/hs/Test/Ganeti/Daemon.hs \
575         test/hs/Test/Ganeti/Errors.hs \
576         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
577         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
578         test/hs/Test/Ganeti/HTools/CLI.hs \
579         test/hs/Test/Ganeti/HTools/Cluster.hs \
580         test/hs/Test/Ganeti/HTools/Container.hs \
581         test/hs/Test/Ganeti/HTools/Graph.hs \
582         test/hs/Test/Ganeti/HTools/Instance.hs \
583         test/hs/Test/Ganeti/HTools/Loader.hs \
584         test/hs/Test/Ganeti/HTools/Node.hs \
585         test/hs/Test/Ganeti/HTools/PeerMap.hs \
586         test/hs/Test/Ganeti/HTools/Types.hs \
587         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
588         test/hs/Test/Ganeti/JSON.hs \
589         test/hs/Test/Ganeti/Jobs.hs \
590         test/hs/Test/Ganeti/JQueue.hs \
591         test/hs/Test/Ganeti/Luxi.hs \
592         test/hs/Test/Ganeti/Network.hs \
593         test/hs/Test/Ganeti/Objects.hs \
594         test/hs/Test/Ganeti/OpCodes.hs \
595         test/hs/Test/Ganeti/Query/Filter.hs \
596         test/hs/Test/Ganeti/Query/Language.hs \
597         test/hs/Test/Ganeti/Query/Network.hs \
598         test/hs/Test/Ganeti/Query/Query.hs \
599         test/hs/Test/Ganeti/Rpc.hs \
600         test/hs/Test/Ganeti/Runtime.hs \
601         test/hs/Test/Ganeti/Ssconf.hs \
602         test/hs/Test/Ganeti/THH.hs \
603         test/hs/Test/Ganeti/TestCommon.hs \
604         test/hs/Test/Ganeti/TestHTools.hs \
605         test/hs/Test/Ganeti/TestHelper.hs \
606         test/hs/Test/Ganeti/Types.hs \
607         test/hs/Test/Ganeti/Utils.hs
608
609 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
610
611 HS_BUILT_SRCS = \
612         test/hs/Test/Ganeti/TestImports.hs \
613         src/Ganeti/Constants.hs \
614         src/Ganeti/Curl/Internal.hs \
615         src/Ganeti/Version.hs
616 HS_BUILT_SRCS_IN = \
617         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
618         src/Ganeti/Curl/Internal.hsc
619
620 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
621
622 $(RUN_IN_TEMPDIR): | stamp-directories
623
624 doc/html/index.html: ENABLE_MANPAGES =
625 doc/man-html/index.html: ENABLE_MANPAGES = 1
626 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
627
628 # Note: we use here an order-only prerequisite, as the contents of
629 # _autoconf.py are not actually influencing the html build output: it
630 # has to exist in order for the sphinx module to be loaded
631 # successfully, but we certainly don't want the docs to be rebuilt if
632 # it changes
633 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
634         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
635         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
636         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
637         | $(BUILT_PYTHON_SOURCES)
638         @test -n "$(SPHINX)" || \
639             { echo 'sphinx-build' not found during configure; exit 1; }
640 if !MANPAGES_IN_DOC
641         if test -n '$(ENABLE_MANPAGES)'; then \
642           echo 'Man pages in documentation were disabled at configure time' >&2; \
643           exit 1; \
644         fi
645 endif
646 ## Sphinx provides little control over what content should be included. Some
647 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
648 ## build two different versions of the documentation--once without man pages and
649 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
650 ## us with this, but requires running in a temporary directory. It moves the
651 ## correct files into place depending on environment variables.
652         dir=$(dir $@) && \
653         @mkdir_p@ $$dir && \
654         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
655         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
656             -d . \
657             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
658             -D release="$(PACKAGE_VERSION)" \
659             -D graphviz_dot="$(DOT)" \
660             -D enable_manpages="$(ENABLE_MANPAGES)" \
661             doc $(CURDIR)/$$dir && \
662         rm -f $$dir/.buildinfo $$dir/objects.inv
663         touch $@
664
665 doc/html: doc/html/index.html
666
667 doc/man-html: doc/man-html/index.html
668
669 doc/install-quick.rst: INSTALL
670 doc/news.rst: NEWS
671 doc/upgrade.rst: UPGRADE
672
673 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
674         set -e; \
675         { echo '.. This file is automatically updated at build time from $<.'; \
676           echo '.. Do not edit.'; \
677           echo; \
678           cat $<; \
679         } > $@
680
681 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
682         { echo '.. This file is automatically generated, do not edit!'; \
683           echo ''; \
684           echo 'Man pages'; \
685           echo '========='; \
686           echo; \
687           echo '.. toctree::'; \
688           echo '   :maxdepth: 1'; \
689           echo; \
690           for i in $(notdir $(mandocrst)); do \
691             echo "   $$i"; \
692           done | LC_ALL=C sort; \
693         } > $@
694
695 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
696 if MANPAGES_IN_DOC
697         { echo '.. This file is automatically updated at build time from $<.'; \
698           echo '.. Do not edit.'; \
699           echo; \
700           echo "$*"; \
701           echo '=========================================='; \
702           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
703         } > $@
704 else
705         echo 'Man pages in documentation were disabled at configure time' >&2; \
706         exit 1;
707 endif
708
709 # Things to build but not to install (add it to EXTRA_DIST if it should be
710 # distributed)
711 noinst_DATA = \
712         doc/html \
713         $(BUILT_EXAMPLES) \
714         doc/examples/bash_completion \
715         doc/examples/bash_completion-debug \
716         $(manhtml)
717
718 if MANPAGES_IN_DOC
719 noinst_DATA += doc/man-html
720 endif
721
722 gnt_scripts = \
723         scripts/gnt-backup \
724         scripts/gnt-cluster \
725         scripts/gnt-debug \
726         scripts/gnt-group \
727         scripts/gnt-instance \
728         scripts/gnt-job \
729         scripts/gnt-network \
730         scripts/gnt-node \
731         scripts/gnt-os \
732         scripts/gnt-storage
733
734 PYTHON_BOOTSTRAP_SBIN = \
735         daemons/ganeti-masterd \
736         daemons/ganeti-noded \
737         daemons/ganeti-rapi \
738         daemons/ganeti-watcher \
739         $(gnt_scripts)
740
741 PYTHON_BOOTSTRAP = \
742         $(PYTHON_BOOTSTRAP_SBIN) \
743         tools/burnin \
744         tools/ensure-dirs \
745         tools/node-cleanup \
746         tools/node-daemon-setup \
747         tools/prepare-node-join
748
749 qa_scripts = \
750         qa/__init__.py \
751         qa/ganeti-qa.py \
752         qa/qa_cluster.py \
753         qa/qa_config.py \
754         qa/qa_daemon.py \
755         qa/qa_env.py \
756         qa/qa_error.py \
757         qa/qa_group.py \
758         qa/qa_instance.py \
759         qa/qa_job.py \
760         qa/qa_node.py \
761         qa/qa_os.py \
762         qa/qa_rapi.py \
763         qa/qa_tags.py \
764         qa/qa_utils.py
765
766 bin_SCRIPTS =
767 if WANT_HTOOLS
768 bin_SCRIPTS += $(HS_BIN_PROGS)
769 install-exec-hook:
770         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
771 # FIXME: this is a hardcoded logic, instead of auto-resolving
772         $(LN_S) -f ../../../bin/htools \
773           $(DESTDIR)$(iallocatorsdir)/hail
774         for role in $(HS_BIN_ROLES); do \
775           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
776         done
777 endif
778
779 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
780         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
781           echo "Error: cannot run unittests without the development" \
782                " libraries (see devnotes.rst)" 1>&2; \
783           exit 1; \
784         fi
785         @rm -f $(notdir $@).tix
786         $(GHC) --make \
787           $(HFLAGS) \
788           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
789           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
790           $(HEXTRA) $(HEXTRA_INT) $@
791         @touch "$@"
792
793 # for the test/hs/htest binary, we need to enable profiling/coverage
794 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
795
796 # we compile the hpc-htools binary with the program coverage
797 test/hs/hpc-htools: HEXTRA_INT=-fhpc
798
799 # we compile the hpc-mon-collector binary with the program coverage
800 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
801
802 # test dependency
803 test/hs/offline-tests.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
804
805 # rules for building profiling-enabled versions of the haskell
806 # programs: hs-prof does the full two-step build, whereas
807 # hs-prof-quick does only the final rebuild (hs-prof must have been
808 # run before)
809 .PHONY: hs-prof hs-prof-quick
810 hs-prof:
811         @if [ -z "$(TARGET)" ]; then \
812           echo "You need to define TARGET when running this rule" 1>&2; \
813           exit 1; \
814         fi
815         $(MAKE) $(AM_MAKEFLAGS) clean
816         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
817         rm -f $(HS_ALL_PROGS)
818         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
819
820 hs-prof-quick:
821         @if [ -z "$(TARGET)" ]; then \
822           echo "You need to define TARGET when running this rule" 1>&2; \
823           exit 1; \
824         fi
825         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
826
827 dist_sbin_SCRIPTS = \
828         tools/ganeti-listrunner
829
830 nodist_sbin_SCRIPTS = \
831         $(PYTHON_BOOTSTRAP_SBIN) \
832         daemons/ganeti-cleaner
833
834 if ENABLE_CONFD
835 src/ganeti-confd: src/hconfd
836         cp -f $< $@
837
838 nodist_sbin_SCRIPTS += src/ganeti-confd
839 endif
840
841 if ENABLE_MOND
842 nodist_sbin_SCRIPTS += src/ganeti-mond
843 endif
844
845 python_scripts = \
846         tools/cfgshell \
847         tools/cfgupgrade \
848         tools/cfgupgrade12 \
849         tools/cluster-merge \
850         tools/confd-client \
851         tools/fmtjson \
852         tools/lvmstrap \
853         tools/move-instance \
854         tools/ovfconverter \
855         tools/sanitize-config
856
857 dist_tools_SCRIPTS = \
858         $(python_scripts) \
859         tools/kvm-console-wrapper \
860         tools/master-ip-setup \
861         tools/xen-console-wrapper
862
863 nodist_tools_python_scripts = \
864         tools/node-cleanup
865
866 nodist_tools_SCRIPTS = \
867         $(nodist_tools_python_scripts) \
868         tools/vcluster-setup
869
870 pkglib_python_scripts = \
871         daemons/import-export \
872         tools/check-cert-expired
873
874 nodist_pkglib_python_scripts = \
875         tools/burnin \
876         tools/ensure-dirs \
877         tools/node-daemon-setup \
878         tools/prepare-node-join
879
880 myexeclib_SCRIPTS = \
881         daemons/daemon-util \
882         tools/kvm-ifup \
883         $(pkglib_python_scripts) \
884         $(HS_MYEXECLIB_PROGS)
885
886 nodist_myexeclib_SCRIPTS = \
887         $(nodist_pkglib_python_scripts)
888
889 EXTRA_DIST = \
890         NEWS \
891         UPGRADE \
892         epydoc.conf.in \
893         pylintrc \
894         autotools/build-bash-completion \
895         autotools/build-rpc \
896         autotools/check-header \
897         autotools/check-imports \
898         autotools/check-man-dashes \
899         autotools/check-man-references \
900         autotools/check-man-warnings \
901         autotools/check-news \
902         autotools/check-python-code \
903         autotools/check-tar \
904         autotools/check-version \
905         autotools/convert-constants \
906         autotools/docpp \
907         autotools/gen-py-coverage \
908         autotools/sphinx-wrapper \
909         autotools/testrunner \
910         autotools/wrong-hardcoded-paths \
911         $(RUN_IN_TEMPDIR) \
912         daemons/daemon-util.in \
913         daemons/ganeti-cleaner.in \
914         $(pkglib_python_scripts) \
915         devel/upload \
916         devel/webserver \
917         tools/kvm-ifup.in \
918         tools/vcluster-setup.in \
919         $(docinput) \
920         doc/html \
921         $(BUILT_EXAMPLES:%=%.in) \
922         doc/examples/ganeti.default \
923         doc/examples/ganeti.default-debug \
924         doc/examples/hooks/ethers \
925         doc/examples/gnt-debug/README \
926         doc/examples/gnt-debug/delay0.json \
927         doc/examples/gnt-debug/delay50.json \
928         test/py/lockperf.py \
929         test/py/testutils.py \
930         test/py/mocks.py \
931         $(dist_TESTS) \
932         $(TEST_FILES) \
933         man/footer.rst \
934         $(manrst) \
935         $(maninput) \
936         qa/qa-sample.json \
937         $(qa_scripts) \
938         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
939         $(HS_PROG_SRCS) \
940         src/lint-hints.hs \
941         test/hs/cli-tests-defs.sh \
942         test/hs/offline-test.sh \
943         .ghci
944
945 man_MANS = \
946         man/ganeti-cleaner.8 \
947         man/ganeti-confd.8 \
948         man/ganeti-listrunner.8 \
949         man/ganeti-masterd.8 \
950         man/ganeti-mond.8 \
951         man/ganeti-noded.8 \
952         man/ganeti-os-interface.7 \
953         man/ganeti-extstorage-interface.7 \
954         man/ganeti-rapi.8 \
955         man/ganeti-watcher.8 \
956         man/ganeti.7 \
957         man/gnt-backup.8 \
958         man/gnt-cluster.8 \
959         man/gnt-debug.8 \
960         man/gnt-group.8 \
961         man/gnt-network.8 \
962         man/gnt-instance.8 \
963         man/gnt-job.8 \
964         man/gnt-node.8 \
965         man/gnt-os.8 \
966         man/gnt-storage.8 \
967         man/hail.1 \
968         man/hbal.1 \
969         man/hcheck.1 \
970         man/hinfo.1 \
971         man/hscan.1 \
972         man/hspace.1 \
973         man/hroller.1 \
974         man/htools.1 \
975         man/mon-collector.7
976
977 # Remove extensions from all filenames in man_MANS
978 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
979
980 manrst = $(patsubst %,%.rst,$(mannoext))
981 manhtml = $(patsubst %.rst,%.html,$(manrst))
982 mangen = $(patsubst %.rst,%.gen,$(manrst))
983 maninput = \
984         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
985         $(patsubst %.html,%.html.in,$(manhtml)) \
986         $(mangen)
987
988 TEST_FILES = \
989         test/data/htools/clean-nonzero-score.data \
990         test/data/htools/common-suffix.data \
991         test/data/htools/empty-cluster.data \
992         test/data/htools/hail-alloc-drbd.json \
993         test/data/htools/hail-change-group.json \
994         test/data/htools/hail-invalid-reloc.json \
995         test/data/htools/hail-node-evac.json \
996         test/data/htools/hail-reloc-drbd.json \
997         test/data/htools/hbal-excl-tags.data \
998         test/data/htools/hbal-split-insts.data \
999         test/data/htools/invalid-node.data \
1000         test/data/htools/missing-resources.data \
1001         test/data/htools/n1-failure.data \
1002         test/data/htools/rapi/groups.json \
1003         test/data/htools/rapi/info.json \
1004         test/data/htools/rapi/instances.json \
1005         test/data/htools/rapi/nodes.json \
1006         test/hs/shelltests/htools-balancing.test \
1007         test/hs/shelltests/htools-basic.test \
1008         test/hs/shelltests/htools-dynutil.test \
1009         test/hs/shelltests/htools-excl.test \
1010         test/hs/shelltests/htools-hail.test \
1011         test/hs/shelltests/htools-hspace.test \
1012         test/hs/shelltests/htools-invalid.test \
1013         test/hs/shelltests/htools-multi-group.test \
1014         test/hs/shelltests/htools-no-backend.test \
1015         test/hs/shelltests/htools-rapi.test \
1016         test/hs/shelltests/htools-single-group.test \
1017         test/hs/shelltests/htools-text-backend.test \
1018         test/hs/shelltests/htools-mon-collector.test \
1019         test/data/bdev-drbd-8.0.txt \
1020         test/data/bdev-drbd-8.3.txt \
1021         test/data/bdev-drbd-disk.txt \
1022         test/data/bdev-drbd-net-ip4.txt \
1023         test/data/bdev-drbd-net-ip6.txt \
1024         test/data/bdev-rbd/json_output_empty.txt \
1025         test/data/bdev-rbd/json_output_extra_matches.txt \
1026         test/data/bdev-rbd/json_output_no_matches.txt \
1027         test/data/bdev-rbd/json_output_ok.txt \
1028         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1029         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1030         test/data/bdev-rbd/plain_output_new_ok.txt \
1031         test/data/bdev-rbd/plain_output_old_empty.txt \
1032         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1033         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1034         test/data/bdev-rbd/plain_output_old_ok.txt \
1035         test/data/bdev-rbd/output_invalid.txt \
1036         test/data/cert1.pem \
1037         test/data/cert2.pem \
1038         test/data/instance-minor-pairing.txt \
1039         test/data/ip-addr-show-dummy0.txt \
1040         test/data/ip-addr-show-lo-ipv4.txt \
1041         test/data/ip-addr-show-lo-ipv6.txt \
1042         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1043         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1044         test/data/ip-addr-show-lo-oneline.txt \
1045         test/data/ip-addr-show-lo.txt \
1046         test/data/kvm_0.12.5_help.txt \
1047         test/data/kvm_0.15.90_help.txt \
1048         test/data/kvm_0.9.1_help.txt \
1049         test/data/kvm_0.9.1_help_boot_test.txt \
1050         test/data/kvm_1.0_help.txt \
1051         test/data/kvm_1.1.2_help.txt \
1052         test/data/ovfdata/compr_disk.vmdk.gz \
1053         test/data/ovfdata/config.ini \
1054         test/data/ovfdata/corrupted_resources.ovf \
1055         test/data/ovfdata/empty.ini \
1056         test/data/ovfdata/empty.ovf \
1057         test/data/ovfdata/ganeti.mf \
1058         test/data/ovfdata/ganeti.ovf \
1059         test/data/ovfdata/gzip_disk.ovf \
1060         test/data/ovfdata/new_disk.vmdk \
1061         test/data/ovfdata/no_disk.ini \
1062         test/data/ovfdata/no_disk_in_ref.ovf \
1063         test/data/ovfdata/no_os.ini \
1064         test/data/ovfdata/no_ovf.ova \
1065         test/data/ovfdata/other/rawdisk.raw \
1066         test/data/ovfdata/ova.ova \
1067         test/data/ovfdata/rawdisk.raw \
1068         test/data/ovfdata/second_disk.vmdk \
1069         test/data/ovfdata/unsafe_path.ini \
1070         test/data/ovfdata/virtualbox.ovf \
1071         test/data/ovfdata/wrong_config.ini \
1072         test/data/ovfdata/wrong_extension.ovd \
1073         test/data/ovfdata/wrong_manifest.mf \
1074         test/data/ovfdata/wrong_manifest.ovf \
1075         test/data/ovfdata/wrong_ova.ova \
1076         test/data/ovfdata/wrong_xml.ovf \
1077         test/data/proc_drbd8.txt \
1078         test/data/proc_drbd80-emptyline.txt \
1079         test/data/proc_drbd83.txt \
1080         test/data/proc_drbd83_sync.txt \
1081         test/data/proc_drbd83_sync_want.txt \
1082         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1083         test/data/qa-minimal-nodes-instances-only.json \
1084         test/data/sys_drbd_usermode_helper.txt \
1085         test/data/vgreduce-removemissing-2.02.02.txt \
1086         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1087         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1088         test/data/vgs-missing-pvs-2.02.02.txt \
1089         test/data/vgs-missing-pvs-2.02.66.txt \
1090         test/data/xen-xm-info-4.0.1.txt \
1091         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1092         test/data/xen-xm-list-4.0.1-four-instances.txt \
1093         test/data/xen-xm-list-long-4.0.1.txt \
1094         test/data/xen-xm-uptime-4.0.1.txt \
1095         test/py/ganeti-cli.test \
1096         test/py/gnt-cli.test \
1097         test/py/import-export_unittest-helper
1098
1099 python_tests = \
1100         doc/examples/rapi_testutils.py \
1101         test/py/cfgupgrade_unittest.py \
1102         test/py/docs_unittest.py \
1103         test/py/ganeti.asyncnotifier_unittest.py \
1104         test/py/ganeti.backend_unittest-runasroot.py \
1105         test/py/ganeti.backend_unittest.py \
1106         test/py/ganeti.bdev_unittest.py \
1107         test/py/ganeti.cli_unittest.py \
1108         test/py/ganeti.client.gnt_cluster_unittest.py \
1109         test/py/ganeti.client.gnt_instance_unittest.py \
1110         test/py/ganeti.client.gnt_job_unittest.py \
1111         test/py/ganeti.cmdlib_unittest.py \
1112         test/py/ganeti.compat_unittest.py \
1113         test/py/ganeti.confd.client_unittest.py \
1114         test/py/ganeti.config_unittest.py \
1115         test/py/ganeti.constants_unittest.py \
1116         test/py/ganeti.daemon_unittest.py \
1117         test/py/ganeti.errors_unittest.py \
1118         test/py/ganeti.hooks_unittest.py \
1119         test/py/ganeti.ht_unittest.py \
1120         test/py/ganeti.http_unittest.py \
1121         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1122         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1123         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1124         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1125         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1126         test/py/ganeti.hypervisor_unittest.py \
1127         test/py/ganeti.impexpd_unittest.py \
1128         test/py/ganeti.jqueue_unittest.py \
1129         test/py/ganeti.jstore_unittest.py \
1130         test/py/ganeti.locking_unittest.py \
1131         test/py/ganeti.luxi_unittest.py \
1132         test/py/ganeti.masterd.iallocator_unittest.py \
1133         test/py/ganeti.masterd.instance_unittest.py \
1134         test/py/ganeti.mcpu_unittest.py \
1135         test/py/ganeti.netutils_unittest.py \
1136         test/py/ganeti.objects_unittest.py \
1137         test/py/ganeti.opcodes_unittest.py \
1138         test/py/ganeti.outils_unittest.py \
1139         test/py/ganeti.ovf_unittest.py \
1140         test/py/ganeti.qlang_unittest.py \
1141         test/py/ganeti.query_unittest.py \
1142         test/py/ganeti.rapi.baserlib_unittest.py \
1143         test/py/ganeti.rapi.client_unittest.py \
1144         test/py/ganeti.rapi.resources_unittest.py \
1145         test/py/ganeti.rapi.rlib2_unittest.py \
1146         test/py/ganeti.rapi.testutils_unittest.py \
1147         test/py/ganeti.rpc_unittest.py \
1148         test/py/ganeti.runtime_unittest.py \
1149         test/py/ganeti.serializer_unittest.py \
1150         test/py/ganeti.server.rapi_unittest.py \
1151         test/py/ganeti.ssconf_unittest.py \
1152         test/py/ganeti.ssh_unittest.py \
1153         test/py/ganeti.storage_unittest.py \
1154         test/py/ganeti.tools.burnin_unittest.py \
1155         test/py/ganeti.tools.ensure_dirs_unittest.py \
1156         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1157         test/py/ganeti.tools.prepare_node_join_unittest.py \
1158         test/py/ganeti.uidpool_unittest.py \
1159         test/py/ganeti.utils.algo_unittest.py \
1160         test/py/ganeti.utils.filelock_unittest.py \
1161         test/py/ganeti.utils.hash_unittest.py \
1162         test/py/ganeti.utils.io_unittest-runasroot.py \
1163         test/py/ganeti.utils.io_unittest.py \
1164         test/py/ganeti.utils.log_unittest.py \
1165         test/py/ganeti.utils.lvm_unittest.py \
1166         test/py/ganeti.utils.mlock_unittest.py \
1167         test/py/ganeti.utils.nodesetup_unittest.py \
1168         test/py/ganeti.utils.process_unittest.py \
1169         test/py/ganeti.utils.retry_unittest.py \
1170         test/py/ganeti.utils.text_unittest.py \
1171         test/py/ganeti.utils.wrapper_unittest.py \
1172         test/py/ganeti.utils.x509_unittest.py \
1173         test/py/ganeti.utils_unittest.py \
1174         test/py/ganeti.vcluster_unittest.py \
1175         test/py/ganeti.workerpool_unittest.py \
1176         test/py/pycurl_reset_unittest.py \
1177         test/py/qa.qa_config_unittest.py \
1178         test/py/tempfile_fork_unittest.py
1179
1180 haskell_tests = test/hs/htest
1181
1182 dist_TESTS = \
1183         test/py/check-cert-expired_unittest.bash \
1184         test/py/daemon-util_unittest.bash \
1185         test/py/ganeti-cleaner_unittest.bash \
1186         test/py/import-export_unittest.bash \
1187         test/py/cli-test.bash \
1188         test/py/bash_completion.bash \
1189         $(python_tests)
1190
1191 nodist_TESTS =
1192 check_SCRIPTS =
1193
1194 if WANT_HSTESTS
1195 nodist_TESTS += $(haskell_tests)
1196 dist_TESTS += test/hs/offline-test.sh
1197 check_SCRIPTS += \
1198         test/hs/hpc-htools \
1199         test/hs/hpc-mon-collector \
1200         $(HS_BUILT_TEST_HELPERS)
1201 endif
1202
1203 TESTS = $(dist_TESTS) $(nodist_TESTS)
1204
1205 # Environment for all tests
1206 PLAIN_TESTS_ENVIRONMENT = \
1207         PYTHONPATH=. \
1208         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1209         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1210         $(RUN_IN_TEMPDIR)
1211
1212 # Environment for tests run by automake
1213 TESTS_ENVIRONMENT = \
1214         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1215
1216 all_python_code = \
1217         $(dist_sbin_SCRIPTS) \
1218         $(python_scripts) \
1219         $(pkglib_python_scripts) \
1220         $(nodist_pkglib_python_scripts) \
1221         $(nodist_tools_python_scripts) \
1222         $(python_tests) \
1223         $(pkgpython_PYTHON) \
1224         $(client_PYTHON) \
1225         $(hypervisor_PYTHON) \
1226         $(rapi_PYTHON) \
1227         $(server_PYTHON) \
1228         $(pytools_PYTHON) \
1229         $(http_PYTHON) \
1230         $(confd_PYTHON) \
1231         $(masterd_PYTHON) \
1232         $(impexpd_PYTHON) \
1233         $(utils_PYTHON) \
1234         $(watcher_PYTHON) \
1235         $(noinst_PYTHON) \
1236         $(qa_scripts)
1237
1238 srclink_files = \
1239         man/footer.rst \
1240         test/py/check-cert-expired_unittest.bash \
1241         test/py/daemon-util_unittest.bash \
1242         test/py/ganeti-cleaner_unittest.bash \
1243         test/py/import-export_unittest.bash \
1244         test/py/cli-test.bash \
1245         test/py/bash_completion.bash \
1246         test/hs/offline-test.sh \
1247         test/hs/cli-tests-defs.sh \
1248         $(all_python_code) \
1249         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1250         $(docinput)
1251
1252 check_python_code = \
1253         $(BUILD_BASH_COMPLETION) \
1254         $(CHECK_IMPORTS) \
1255         $(CHECK_HEADER) \
1256         $(DOCPP) \
1257         $(all_python_code)
1258
1259 lint_python_code = \
1260         ganeti \
1261         ganeti/http/server.py \
1262         $(dist_sbin_SCRIPTS) \
1263         $(python_scripts) \
1264         $(pkglib_python_scripts) \
1265         $(BUILD_BASH_COMPLETION) \
1266         $(CHECK_IMPORTS) \
1267         $(CHECK_HEADER) \
1268         $(DOCPP) \
1269         $(PYTHON_BOOTSTRAP)
1270
1271 standalone_python_modules = \
1272         lib/rapi/client.py \
1273         tools/ganeti-listrunner
1274
1275 pep8_python_code = \
1276         ganeti \
1277         ganeti/http/server.py \
1278         $(dist_sbin_SCRIPTS) \
1279         $(python_scripts) \
1280         $(pkglib_python_scripts) \
1281         $(BUILD_BASH_COMPLETION) \
1282         $(CHECK_HEADER) \
1283         $(DOCPP) \
1284         $(PYTHON_BOOTSTRAP) \
1285         qa
1286
1287 test/py/daemon-util_unittest.bash: daemons/daemon-util
1288
1289 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1290
1291 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1292
1293 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1294         sed -f $(REPLACE_VARS_SED) < $< > $@
1295         chmod +x $@
1296
1297 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1298         sed -f $(REPLACE_VARS_SED) < $< > $@
1299         chmod +x $@
1300
1301 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1302         sed -f $(REPLACE_VARS_SED) < $< > $@
1303         chmod +x $@
1304
1305 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1306         sed -f $(REPLACE_VARS_SED) < $< > $@
1307
1308 doc/examples/bash_completion: BC_ARGS = --compact
1309 doc/examples/bash_completion-debug: BC_ARGS =
1310
1311 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1312         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1313         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1314         daemons/ganeti-cleaner \
1315         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1316         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1317           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1318
1319 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1320         lib/build/shell_example_lexer.py \
1321         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1322         @echo "Checking $< for hardcoded paths..."
1323         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1324           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1325           exit 1; \
1326         fi
1327         set -e ; \
1328         trap 'echo auto-removing $@; rm $@' EXIT; \
1329         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1330         $(CHECK_MAN_REFERENCES) $@; \
1331         trap - EXIT
1332
1333 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1334         @test -n "$(PANDOC)" || \
1335           { echo 'pandoc' not found during configure; exit 1; }
1336         set -o pipefail -e; \
1337         trap 'echo auto-removing $@; rm $@' EXIT; \
1338         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1339           sed -e 's/\\@/@/g' > $@; \
1340         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1341         $(CHECK_MAN_DASHES) $@; \
1342         trap - EXIT
1343
1344 man/%.html.in: man/%.gen man/footer.rst
1345         @test -n "$(PANDOC)" || \
1346           { echo 'pandoc' not found during configure; exit 1; }
1347         set -o pipefail ; \
1348         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1349           sed -e 's/\\@/@/g' > $@
1350
1351 man/%: man/%.in  $(REPLACE_VARS_SED)
1352         sed -f $(REPLACE_VARS_SED) < $< > $@
1353
1354 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1355         sed -f $(REPLACE_VARS_SED) < $< > $@
1356
1357 vcs-version:
1358         if test -d .git; then \
1359           git describe > $@; \
1360         elif test ! -f $@ ; then \
1361           echo "Cannot auto-generate $@ file"; exit 1; \
1362         fi
1363
1364 .PHONY: clean-vcs-version
1365 clean-vcs-version:
1366         rm -f vcs-version
1367
1368 .PHONY: regen-vcs-version
1369 regen-vcs-version:
1370         @set -e; \
1371         cd $(srcdir); \
1372         if test -d .git; then \
1373           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1374           git describe > $$T; \
1375           if ! cmp --quiet $$T vcs-version; then \
1376             mv $$T vcs-version; \
1377           fi; \
1378         fi
1379
1380 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1381         vcs-version $(built_base_sources)
1382         set -e; \
1383         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1384         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1385
1386 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1387         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1388         lib/jstore.py $(RUN_IN_TEMPDIR) \
1389         $(CONVERT_CONSTANTS) $(built_base_sources) \
1390         | lib/_vcsversion.py
1391         set -e; \
1392         { cat $< ; \
1393           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1394         } > $@
1395
1396 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1397         hsc2hs -o $@ $<
1398
1399 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1400         $(built_base_sources)
1401         set -e; \
1402         { cat $< ; \
1403           echo ; \
1404           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1405             echo "import $$name ()" ; \
1406           done ; \
1407         } > $@
1408
1409 lib/_autoconf.py: Makefile | stamp-directories
1410         set -e; \
1411         { echo '# This file is automatically generated, do not edit!'; \
1412           echo '#'; \
1413           echo ''; \
1414           echo '"""Build-time configuration for Ganeti.'; \
1415           echo '';\
1416           echo 'This file is autogenerated by the build process.'; \
1417           echo 'For any changes you need to re-run ./configure (and'; \
1418           echo 'not edit by hand).'; \
1419           echo ''; \
1420           echo '"""'; \
1421           echo ''; \
1422           echo '# pylint: disable=C0301,C0324'; \
1423           echo '# because this is autogenerated, we do not want'; \
1424           echo '# style warnings' ; \
1425           echo ''; \
1426           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1427           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1428           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1429           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1430           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1431           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1432           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1433           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1434           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1435           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1436           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1437           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1438           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1439           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1440           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1441           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1442           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1443           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1444           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1445           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1446           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1447           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1448           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1449           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1450           echo "KVM_PATH = '$(KVM_PATH)'"; \
1451           echo "IP_PATH = '$(IP_PATH)'"; \
1452           echo "SOCAT_PATH = '$(SOCAT)'"; \
1453           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1454           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1455           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1456           echo "TOOLSDIR = '$(toolsdir)'"; \
1457           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1458           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1459           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1460           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1461           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1462           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1463           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1464           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1465           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1466           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1467           echo "RAPI_USER = '$(RAPI_USER)'"; \
1468           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1469           echo "CONFD_USER = '$(CONFD_USER)'"; \
1470           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1471           echo "NODED_USER = '$(NODED_USER)'"; \
1472           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1473           echo "MOND_USER = '$(MOND_USER)'"; \
1474           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1475           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1476           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1477           echo "HTOOLS = True"; \
1478           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1479           echo "XEN_CMD = '$(XEN_CMD)'"; \
1480           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1481           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1482           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1483 ## Write dictionary with man page name as the key and the section number as the
1484 ## value
1485           echo "MAN_PAGES = {"; \
1486           for i in $(notdir $(man_MANS)); do \
1487             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1488           done; \
1489           echo "}"; \
1490         } > $@
1491
1492 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1493         set -e; \
1494         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1495         { echo '# This file is automatically generated, do not edit!'; \
1496           echo '#'; \
1497           echo ''; \
1498           echo '"""Build-time VCS version number for Ganeti.'; \
1499           echo '';\
1500           echo 'This file is autogenerated by the build process.'; \
1501           echo 'For any changes you need to re-run ./configure (and'; \
1502           echo 'not edit by hand).'; \
1503           echo ''; \
1504           echo '"""'; \
1505           echo ''; \
1506           echo '# pylint: disable=C0301,C0324'; \
1507           echo '# because this is autogenerated, we do not want'; \
1508           echo '# style warnings' ; \
1509           echo ''; \
1510           echo "VCS_VERSION = '$$VCSVER'"; \
1511         } > $@
1512
1513 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1514         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1515
1516 $(SHELL_ENV_INIT): Makefile stamp-directories
1517         set -e; \
1518         { echo '# Allow overriding for tests'; \
1519           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1520           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1521           echo; \
1522           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1523           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1524           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1525           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1526           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1527         } > $@
1528
1529 ## Writes sed script to replace placeholders with build-time values. The
1530 ## additional quotes after the first @ sign are necessary to stop configure
1531 ## from replacing those values as well.
1532 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1533         set -e; \
1534         { echo 's#@''PREFIX@#$(prefix)#g'; \
1535           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1536           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1537           echo 's#@''BINDIR@#$(bindir)#g'; \
1538           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1539           echo 's#@''LIBDIR@#$(libdir)#g'; \
1540           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1541           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1542           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1543           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1544           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1545           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1546           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1547           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1548           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1549           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1550           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1551           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1552           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1553           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1554           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1555           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1556           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1557           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1558           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1559           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1560           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1561           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1562           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1563           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1564           echo; \
1565           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1566           echo '  r $(SHELL_ENV_INIT)'; \
1567           echo '  d'; \
1568           echo '}'; \
1569         } > $@
1570
1571 # Using deferred evaluation
1572 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1573 daemons/ganeti-watcher: MODULE = ganeti.watcher
1574 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1575 tools/burnin: MODULE = ganeti.tools.burnin
1576 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1577 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1578 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1579 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1580 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1581
1582 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1583         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1584         set -e; \
1585         { echo '#!/usr/bin/python'; \
1586           echo '# This file is automatically generated, do not edit!'; \
1587           echo "# Edit $(MODULE) instead."; \
1588           echo; \
1589           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1590           echo; \
1591           echo '# pylint: disable=C0103'; \
1592           echo '# C0103: Invalid name'; \
1593           echo; \
1594           echo 'import sys'; \
1595           echo 'import $(MODULE) as main'; \
1596           echo; \
1597           echo '# Temporarily alias commands until bash completion'; \
1598           echo '# generator is changed'; \
1599           echo 'if hasattr(main, "commands"):'; \
1600           echo '  commands = main.commands # pylint: disable=E1101'; \
1601           echo 'if hasattr(main, "aliases"):'; \
1602           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1603           echo; \
1604           echo 'if __name__ == "__main__":'; \
1605           echo '  sys.exit(main.Main())'; \
1606         } > $@
1607         chmod u+x $@
1608
1609 $(HS_BUILT_TEST_HELPERS): Makefile
1610         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1611         set -e; \
1612         { echo '#!/bin/sh'; \
1613           echo '# This file is automatically generated, do not edit!'; \
1614           echo "# Edit Makefile.am instead."; \
1615           echo; \
1616           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1617         } > $@
1618         chmod u+x $@
1619
1620 stamp-directories: Makefile
1621         $(MAKE) $(AM_MAKEFLAGS) ganeti
1622         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1623         touch $@
1624
1625 # We need to create symlinks because "make distcheck" will not install Python
1626 # files when building.
1627 stamp-srclinks: Makefile | stamp-directories
1628         set -e; \
1629         for i in $(srclink_files); do \
1630           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1631             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1632           fi; \
1633         done
1634         touch $@
1635
1636 .PHONY: ganeti
1637 ganeti:
1638         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1639
1640 .PHONY: check-dirs
1641 check-dirs: $(GENERATED_FILES)
1642         @set -e; \
1643         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1644           error=; \
1645           while read dir; do \
1646             case "$$dir" in \
1647               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1648               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1649             esac; \
1650           done; \
1651           for dir in $(DIRS); do \
1652             if ! test -d "$$dir"; then \
1653               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1654               error=1; \
1655             fi \
1656           done; \
1657           test -z "$$error"; \
1658         }
1659
1660 .PHONY: check-local
1661 check-local: check-dirs $(GENERATED_FILES)
1662         $(CHECK_PYTHON_CODE) $(check_python_code)
1663         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1664         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1665         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1666         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1667         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1668         error= ; \
1669         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1670           echo "Incorrect version in README, expected $$expver" >&2; \
1671           error=1; \
1672         fi; \
1673         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1674             doc/security.rst; do \
1675           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1676             "Documents Ganeti version $$expver"; then \
1677             echo "Incorrect version in $$file, expected $$expver" >&2; \
1678             error=1; \
1679           fi; \
1680         done; \
1681         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1682           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1683           error=1; \
1684         fi; \
1685         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1686           ".. Last updated for Ganeti $$expver"; then \
1687           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1688           error=1; \
1689         fi; \
1690         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1691           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1692             echo "Longest line in $$file is longer than 80 characters" >&2; \
1693             error=1; \
1694           fi; \
1695         done; \
1696         test -z "$$error"
1697
1698 .PHONY: hs-tests
1699 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1700         @rm -f htest.tix
1701         ./test/hs/htest
1702
1703 .PHONY: hs-shell
1704 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1705         @rm -f hpc-htools.tix hpc-mon-collector.tix
1706         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1707
1708 .PHONY: hs-check
1709 hs-check: hs-tests hs-shell
1710
1711 # E111: indentation is not a multiple of four
1712 # E121: continuation line indentation is not a multiple of four
1713 #       (since our indent level is not 4)
1714 # E125: continuation line does not distinguish itself from next logical line
1715 #       (since our indent level is not 4)
1716 # E127: continuation line over-indented for visual indent
1717 #       (since our indent level is not 4)
1718 # note: do NOT add E128 here; it's a valid style error in most cases!
1719 # I've seen real errors, but also some cases were we indent wrongly
1720 # due to line length; try to rework the cases where it is triggered,
1721 # instead of silencing it
1722 # E261: at least two spaces before inline comment
1723 # E501: line too long (80 characters)
1724 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1725
1726 # For excluding pep8 expects filenames only, not whole paths
1727 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1728
1729 LINT_TARGETS = pylint pylint-qa
1730 if HAS_PEP8
1731 LINT_TARGETS += pep8
1732 endif
1733 if HAS_HLINT
1734 LINT_TARGETS += hlint
1735 endif
1736
1737 .PHONY: lint
1738 lint: $(LINT_TARGETS)
1739
1740 .PHONY: pylint
1741 pylint: $(GENERATED_FILES)
1742         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1743         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1744
1745 .PHONY: pylint-qa
1746 pylint-qa: $(GENERATED_FILES)
1747         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1748         cd $(top_srcdir)/qa && \
1749           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1750           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1751
1752 .PHONY: pep8
1753 pep8: $(GENERATED_FILES)
1754         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1755         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1756           --repeat $(pep8_python_code)
1757
1758 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1759 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1760 .PHONY: hlint
1761 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1762         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1763         @rm -f doc/hs-lint.html
1764         if tty -s; then C="-c"; else C=""; fi; \
1765         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1766           --ignore "Use first" \
1767           --ignore "Use &&&" \
1768           --ignore "Use void" \
1769           --ignore "Reduce duplication" \
1770           --hint src/lint-hints \
1771           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1772         @if [ ! -f doc/hs-lint.html ]; then \
1773           echo "All good" > doc/hs-lint.html; \
1774         fi
1775
1776 # a dist hook rule for updating the vcs-version file; this is
1777 # hardcoded due to where it needs to build the file...
1778 dist-hook:
1779         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1780         rm -f $(top_distdir)/vcs-version
1781         cp -p $(srcdir)/vcs-version $(top_distdir)
1782
1783 # a distcheck hook rule for catching revision control directories
1784 distcheck-hook:
1785         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1786           echo "Found revision control files in final archive." 1>&2; \
1787           exit 1; \
1788         fi
1789         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1790           echo "Found Python byte code in final archive." 1>&2; \
1791           exit 1; \
1792         fi
1793         if find $(top_distdir) -name '*~' | grep .; then \
1794           echo "Found backup files in final archive." 1>&2; \
1795           exit 1; \
1796         fi
1797 # Empty files or directories should not be distributed. They can cause
1798 # unnecessary warnings for packagers. Directories used by automake during
1799 # distcheck must be excluded.
1800         if find $(top_distdir) -empty -and -not \( \
1801             -path $(top_distdir)/_build -or \
1802             -path $(top_distdir)/_inst \) | grep .; then \
1803           echo "Found empty files or directories in final archive." 1>&2; \
1804           exit 1; \
1805         fi
1806         if test -n "$(BUILD_RELEASE)" && \
1807            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1808            echo "Found unreleased version in NEWS." >&2; \
1809            exit 1; \
1810         fi
1811         if test -e $(top_distdir)/doc/man-html; then \
1812           echo "Found documentation including man pages in final archive" >&2; \
1813           exit 1; \
1814         fi
1815
1816 # When building a release, stricter checks should be used
1817 distcheck-release dist-release: export BUILD_RELEASE = 1
1818 distcheck-release: distcheck
1819
1820 distrebuildcheck: dist
1821         set -e; \
1822         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1823         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1824         cd $$builddir; \
1825         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1826         cd $(distdir); \
1827         ./configure; \
1828         $(MAKE) maintainer-clean; \
1829         cp $(abs_srcdir)/vcs-version .; \
1830         ./configure; \
1831         $(MAKE) $(AM_MAKEFLAGS)
1832
1833 dist-release: dist
1834         set -e; \
1835         for i in $(DIST_ARCHIVES); do \
1836           echo -n "Checking $$i ... "; \
1837           autotools/check-tar < $$i; \
1838           echo OK; \
1839         done
1840
1841 install-exec-local:
1842         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1843           "$(DESTDIR)${localstatedir}/log/ganeti" \
1844           "$(DESTDIR)${localstatedir}/run/ganeti"
1845
1846 .PHONY: apidoc
1847 if WANT_HSAPIDOC
1848 apidoc: py-apidoc hs-apidoc
1849 else
1850 apidoc: py-apidoc
1851 endif
1852
1853 .PHONY: py-apidoc
1854 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1855         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1856         $(RUN_IN_TEMPDIR) epydoc -v \
1857           --conf $(CURDIR)/epydoc.conf \
1858           --output $(CURDIR)/$(APIDOC_PY_DIR)
1859
1860 .PHONY: hs-apidoc
1861 hs-apidoc: $(APIDOC_HS_DIR)/index.html
1862
1863 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
1864         @test -n "$(HSCOLOUR)" || \
1865             { echo 'HsColour' not found during configure; exit 1; }
1866         @test -n "$(HADDOCK)" || \
1867             { echo 'haddock' not found during configure; exit 1; }
1868         rm -rf $(APIDOC_HS_DIR)/*
1869         for i in $(ALL_APIDOC_HS_DIRS); do \
1870           @mkdir_p@ $$i; \
1871           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
1872         done
1873         set -e ; \
1874         export LC_ALL=en_US.UTF-8; \
1875         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
1876         if [ "$(HS_PARALLEL3)" ]; \
1877         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
1878         fi; \
1879         if [ "$(HS_REGEX_PCRE)" ]; \
1880         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
1881         fi; \
1882         for file in $(HS_LIBTESTBUILT_SRCS); do \
1883           f_nosrc=$${file##src/}; \
1884           f_notst=$${f_nosrc##test/hs/}; \
1885           f_html=$${f_notst%%.hs}.html; \
1886           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
1887         done ; \
1888         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1889           -t ganeti -p src/haddock-prologue \
1890           --source-module="%{MODULE/.//}.html" \
1891           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1892           $$OPTGHC \
1893           $(HS_LIBTESTBUILT_SRCS)
1894
1895 .PHONY: TAGS
1896 TAGS: $(GENERATED_FILES)
1897         rm -f TAGS
1898         $(GHC) -e ":etags" -v0 \
1899           $(filter-out -O -Werror,$(HFLAGS)) \
1900           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
1901           $(HS_LIBTEST_SRCS)
1902         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1903           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1904           -path './qa/*.py' | \
1905           etags -l python -a -
1906
1907 .PHONY: coverage
1908 if WANT_HTOOLS
1909 coverage: py-coverage hs-coverage
1910 else
1911 coverage: py-coverage
1912 endif
1913
1914 .PHONY: py-coverage
1915 py-coverage: $(GENERATED_FILES) $(python_tests)
1916         @test -n "$(PYCOVERAGE)" || \
1917             { echo 'python-coverage' not found during configure; exit 1; }
1918         set -e; \
1919         COVERAGE=$(PYCOVERAGE) \
1920         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1921         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1922         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1923         $(PLAIN_TESTS_ENVIRONMENT) \
1924         $(abs_top_srcdir)/autotools/gen-py-coverage \
1925         $(python_tests)
1926
1927 .PHONY: hs-coverage
1928 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
1929         rm -f *.tix
1930         $(MAKE) $(AM_MAKEFLAGS) hs-check
1931         @mkdir_p@ $(COVERAGE_HS_DIR)
1932         hpc sum --union $(HPCEXCL) \
1933           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
1934         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
1935         hpc report coverage-hs.tix
1936         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1937
1938 # Special "kind-of-QA" target for htools, needs special setup (all
1939 # tools compiled with -fhpc)
1940 .PHONY: live-test
1941 live-test: all
1942         set -e ; \
1943         cd src; \
1944         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1945         rm -f *.tix *.mix; \
1946         ./live-test.sh; \
1947         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
1948           --output=live-test.tix ; \
1949         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1950         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1951           --srcdir=.. $(HPCEXCL) ; \
1952         hpc report --srcdir=.. live-test $(HPCEXCL)
1953
1954 commit-check: distcheck lint apidoc
1955
1956 .PHONY: gitignore-check
1957 gitignore-check:
1958         @if [ -n "`git status --short`" ]; then \
1959           echo "Git status is not clean!" 1>&2 ; \
1960           git status --short; \
1961           exit 1; \
1962         fi
1963
1964 # target to rebuild all man pages (both groff and html output)
1965 .PHONY: man
1966 man: $(man_MANS) $(manhtml)
1967
1968 # Target that builds all binaries (including those that are not
1969 # rebuilt except when running the tests)
1970 .PHONY: really-all
1971 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
1972
1973 # we don't need the ancient implicit rules:
1974 %: %,v
1975 %: RCS/%,v
1976 %: RCS/%
1977 %: s.%
1978 %: SCCS/s.%
1979
1980 -include ./Makefile.local
1981
1982 # vim: set noet :